import * as express from 'express';
import { MongoClient } from 'mongodb';
import * as fs from 'fs';

const config = JSON.parse(fs.readFileSync('./config/config.json', {encoding: 'utf8'}));

const dbClient = new MongoClient(config.dbconnectionURL);

let db;

console.log('connecting to mongodb database...');
dbClient.connect((err) => {
	if (err) return console.log(err);
	console.log('connected to database!');

	db = dbClient.db(config.dbname);
	const app = express();

	app.use(express.urlencoded({ extended: true }));

	app.set('db', db);
	app.set('config', config);

	app.get('/' + config.addtopath, (req, res) => {
		res.send(`${config.name} homepage - unfinished`);
	});

	require('./getGJLevels21')(app);
	require('./uploadGJLevel21')(app);
	require('./downloadGJLevel22')(app);

	app.get('*', (req, res) => res.status(404).send('wrong page dumbass'));

	app.listen(config.port, () => {
		console.log(`expressjs server launched on port ${config.port}, gdps should now function properly`);
	});
});